import gql from 'graphql-tag' // eslint-disable-line no-unused-vars
import apolloProvider from '../plugins/apollo'

export default {
    async conncetion(input){
        try{
            const response = await apolloProvider.defaultClient.query({
                query: gql`
                    query neuroAoiSerial($serial: String!) {
                        neuroAoiSerial(serial: $serial) {
                            uid
                            projectUid
                            name
                            state
                            serial
                            etc
                            updateDate
                            createDate
                        }
                    }`,
                fetchPolicy: 'no-cache',
                variables: { serial: input }
            })

        let aoi = response.data.neuroAoiSerial

        console.log('aoi :',aoi)

        return aoi
        
        }catch (e) { 
            return false
        }
    },

    async getAois(){
        try{
            const response = await apolloProvider.defaultClient.query({
                query: gql`
                    {
                        neuroAois{
                            uid                  
                            name                
                            state                
                            serial               
                            etc                  
                            projectUid
                            createDate            
                            updateDate  
                        }
                    }
                `,
                fetchPolicy: 'no-cache'

            })

            console.log('gql 에서 생성하는 :', response.data.neuroAois)

            let aois = response.data.neuroAois

            if (!aois) return ''

            if (aois.errors)  throw new Error(aois.errors[0])
            
            return aois

        }catch (e) { 
            console.log(e)
            throw e 
        }
    },

    async updateAoi(input){
        try{
            const response = await apolloProvider.defaultClient.mutate({
                mutation: gql`
                    mutation updateNeuroAoi( $name: String! ,$state: Boolean! ,$createDate: String! , $serial:String! , $etc:String! ,$updateDate:String! ,$uid:Int! , $projectUid:Int ){
                        updateNeuroAoi(input:{
                            name:$name
                            state:$state
                            createDate:$createDate
                            serial:$serial
                            etc:$etc
                            updateDate:$updateDate
                            projectUid:$projectUid
                            uid:$uid
                        })
                        {
                            neuroAoi{
                                uid                  
                                name                
                                state                
                                serial               
                                etc                  
                                createDate            
                                updateDate
                                projectUid
                            }
                        }
                    }
                `,
                variables: {
                    uid:input.uid,              
                    name:input.name,            
                    state:input.state,                
                    serial:input.serial,               
                    etc:input.etc,                   
                    createDate:input.createDate,                  
                    updateDate:new Date(),    
                    projectUid:0
                }
            })

        let aoi = response.data.updateNeuroAoi.neuroAoi

        if (!aoi) return ''

        if (aoi.errors){
            throw new Error(aoi.errors[0])
        } 
        
        return aoi

        }catch (e) { 
            console.log(e)
            throw e 
        }
    },

}