import aoiGQL from '../../gql/aoi'

const state = {
    aois: [],
}

const getters = {
}

const actions = {
    async getAois({commit}){
        let result = await aoiGQL.getAois()        

        commit('GETAOIS' , result)
    },

    async createAoi({commit} , input){
        let result = await aoiGQL.createAoi(input)
        commit('CREATEPAOI' , result)
    },

    async updateAoi({commit} , input){

        let result = await aoiGQL.updateAoi(input)

        commit('UPDATEAOI' , result)
    },

    async deleteAoi({commit} , uid){
        let result = await aoiGQL.deleteAoi(uid)

        commit('DELETEAOI' , result)
    }
}

const mutations = {
    GETAOIS(state,payload ){
        state.aois = payload
    },
    
    CREATEPAOI(state,payload ){
        state.aois.push(payload)
    },

    UPDATEAOI(state,payload){
        let updateIndex =state.aois.findIndex( aoi => aoi.uid === payload.uid )
        state.aois.splice(updateIndex , 1 ,payload)
    },

    DELETEAOI(state,payload ){
        let removeIndex = state.aois.findIndex( aoi => aoi.uid === payload )
        state.aois.splice(removeIndex , 1 )
    }  
}

export default {
    state: {
        ...state
    },
    getters,
    mutations,
    actions
}